summaryrefslogtreecommitdiff
path: root/tools/maint/copyright.sh
diff options
context:
space:
mode:
authorCyrille Bagard <nocbos@gmail.com>2020-02-04 16:58:54 (GMT)
committerCyrille Bagard <nocbos@gmail.com>2020-02-04 16:58:54 (GMT)
commit114c7f0f977ca7253cc179393b0cbd404d3f1bf5 (patch)
treed541e63538a9b13e6841db55190cbeea0e9ca4e7 /tools/maint/copyright.sh
parente30bf54b0480823a90ba2f856776d4056d46759a (diff)
Updated copyright headers.
Diffstat (limited to 'tools/maint/copyright.sh')
-rwxr-xr-xtools/maint/copyright.sh46
1 files changed, 46 insertions, 0 deletions
diff --git a/tools/maint/copyright.sh b/tools/maint/copyright.sh
new file mode 100755
index 0000000..6dff6b7
--- /dev/null
+++ b/tools/maint/copyright.sh
@@ -0,0 +1,46 @@
+#!/bin/bash
+
+GITCMD="git log --pretty=format:%ad --date=format:%Y "
+
+function get_min_date()
+{
+ $GITCMD $1 | tail -1
+}
+
+function get_max_date()
+{
+ $GITCMD $1 | head -1
+}
+
+function process_c_file()
+{
+ filename=$1
+
+ echo "Processing $filename..."
+
+ min=$( get_min_date $filename )
+
+ max=$( get_max_date $filename )
+
+ if [ "$min" -eq "$max" ]; then
+ timestamp="$min"
+ else
+ timestamp="$min-$max"
+ fi
+
+ sed -i "s# \* Copyright (C) [0-9-]* Cyrille Bagard# \* Copyright (C) $timestamp Cyrille Bagard#" $filename
+
+}
+
+
+if [ ! -f configure.ac ]; then
+ echo "This script has to be run from the top directory."
+ exit 1
+fi
+
+for file in $( find . -name '*.[ch]' -exec grep -l 'Copyright.*Cyrille Bagard$' {} \; );
+do
+ git ls-files --error-unmatch $file > /dev/null 2>&1 \
+ && process_c_file $file
+
+done